package com.cert.Chapter_2;
//Example of tight coupling
public class Coupling {
	float area;
	float doSquare() {
		Rectangle rec = new Rectangle();
		return rec.length * rec.width;
	}
}
final class Rectangle {
	public float length, width;
	Coupling coupl = new Coupling();
	
	public float getArea(String name){
		length = coupl.doSquare();
		width = coupl.doSquare();
		return length * width;
	}
}

//With light coupling
final class Shape {
	private float length, width;

	public void setWidth(float width) {
		this.width = width;
	}

	public float getWidth() {
		return width;
	}

	public void setLength(float length) {
		this.length = length;
	}

	public float getLength() {
		return length;
	}
	
	public float getArea(){
		return getLength() * getWidth();
	}
}