package com.cert.Chapter_7;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class GenericsCollections {

	public static void main(String[] args) {
		System.out.println("GenericsCollections");

		List myL = new ArrayList(); // can't declare a type
		myL.add("Fred"); // OK, it will hold Strings
		myL.add(new Dog()); // and it will hold Dogs too
		myL.add(new Integer(42)); // and Integers...

		List<String> myList = new ArrayList<String>(); // "parameterized type,"

		Map<String,String> myHash = new HashMap<String,String>(); // "parameterized type,"
		myHash.put("a", "b");
		//myHash.put("aa", 111);
		
		// "type parameter,"
		myList.add("Fred");
		// OK, it will hold Strings
		 //myList.add(new Dog());
		// compiler error!!
		List<String> list = new ArrayList<String>();
		List<Integer> listInt = new ArrayList<Integer>();
		GenericsCollections gc = new GenericsCollections();
//		 gc.takeListOfStrings( listInt );
		gc.takeListOfStrings(list);
	}

	// declare a type parameter for a method argument, which
	// then makes the argument a type safe reference
	private void takeListOfStrings(List<String> strings) {
		strings.add("foo"); // no problem adding a String
	}

	public List getDogList() {
		List<Integer> dogs = new ArrayList<Integer>();
		// more code to insert dogs
		return dogs;
	}

	public static class Dog {
		public Dog() {
			System.out.println("Dog");
		}
		public String toString(){
			return "dog";
		}
	}
	
//	public Point<Integer,Integer,Integer> getPoint {
//		return new Pont();
//	}
}
